module.exports = {
  create: {
    requestBody: [
      "name",
      "address",
      "postal",
      "web_site",
      "register_type",
      "field",
      "register_time",
      "funds",
      "register_address",
      "brief",
      "legal_person",
      "person_number",
      "bk_number",
      "research_number",
      "advanced_number",
      "contact",
      "contact_tel",
      "email",
      "qq",
      "products",
      "requirement",
      "techol_name",
      "urgent",
      "cooperation",
      "budget",
    ],
  },
  destroy: {
    params: ["!id"],
    service: "delete",
  },
  update: {
    params: ["!id"],
    requestBody: [
      "name",
      "address",
      "postal",
      "web_site",
      "register_type",
      "field",
      "register_time",
      "funds",
      "register_address",
      "brief",
      "legal_person",
      "person_number",
      "bk_number",
      "research_number",
      "advanced_number",
      "contact",
      "contact_tel",
      "email",
      "qq",
      "products",
      "requirement",
      "techol_name",
      "urgent",
      "cooperation",
      "budget",
    ],
  },
  show: {
    parameters: {
      params: ["!id"],
    },
    service: "fetch",
  },
  index: {
    parameters: {
      query: {
        "meta.createdAt@start": "meta.createdAt@start",
        "meta.createdAt@end": "meta.createdAt@end",
        name: "name",
        field: "field",
        register_time: "register_time",
        register_type: "register_type",
        contact_tel: "contact_tel",
      },
      // options: {
      //   "meta.state": 0 // 默认条件
      // },
    },
    service: "query",
    options: {
      query: ["skip", "limit"],
      sort: ["meta.createdAt"],
      desc: true,
      count: true,
    },
  },
};
