/* eslint valid-jsdoc: "off" */

'use strict';

/**
 * @param {Egg.EggAppInfo} appInfo app info
 */
module.exports = appInfo => {
  /**
   * built-in config
   * @type {Egg.EggAppConfig}
   **/
  const config = exports = {};

  // use for cookie sign key, should change to your own and keep security
  config.keys = appInfo.name + '_1617689037805_3801';

  // add your middleware config here
  config.middleware = [];

  // add your user config here
  const userConfig = {
    // myAppName: 'egg',
  };
  config.cluster = {
    listen: {
      port: 9104,
    },
  };

  config.dbName = 'question';
  config.mongoose = {
    url: `mongodb://localhost:27017/${config.dbName}`,
    options: {
      // user: 'admin',
      // pass: '111111',
      // authSource: 'admin',
      // useNewUrlParser: true,
      // useCreateIndex: true,
    },
  };
  config.project = {
    live: 'http://127.0.0.1:9101/api/live/v0',
  };
  config.baseUrl = 'http://broadcast.waityou24.cn';
  config.wxapi = {
    appid: 'wx6db5d25b3e7cfc14', // 微信公众号APPID
    baseUrl: 'http://wx.cc-lotus.info', // 微信网关地址
  };


  return {
    ...config,
    ...userConfig,
  };
};
